//##Bugatti Veyron 16.4##//

datablock TSShapeConstructor(BoltDts)
{
	baseShape  = "./Bolt.dts";
	sequence0  = "./Root.dsq root";
	sequence1  = "./SpoilerOpen.dsq open";
	sequence2  = "./SpoilerClose.dsq close";
};

datablock TSShapeConstructor(SuperBoltDts)
{
	baseShape  = "./SuperBolt.dts";
	sequence0  = "./Root.dsq root";
	sequence1  = "./SpoilerOpen.dsq open";
	sequence2  = "./SpoilerClose.dsq close";
};

datablock WheeledVehicleData(BoltVehicle)
{
   isCustom=1;
   type="Bolt";
	uiName = "Bolt";
	
	shapeFile = "./Bolt.dts";
	category = "Vehicles";
	displayName = " ";
	emap = true;
	minMountDist = 3;
   
   numMountPoints = 2;
   mountThread[0] = "sit";
   mountThread[1] = "sit";

	maxDamage = 250.00;
	destroyedLevel = 250.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 0.5";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.86;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 10;         // Far distance from vehicle
	cameraOffset = 6;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = false;	

	defaultTire	= BoltTire;
	defaultSpring	= BoltSpring;
	flatTire	= jeepFlatTire;
	flatSpring	= jeepFlatSpring;

   numWheels = 4;

	// Rigid Body
	mass = 330;
	density = 5.0;
	drag = 4.5;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 8500; //4000;       // Engine power
	engineBrake = 1500;         // Braking when throttle is 0
	brakeTorque = 7000;        // When brakes are applied
	maxWheelSpeed = 65;        // Engine scale by current speed / max speed

	rollForce		= 600;
	yawForce		= 600;
	pitchForce		= 1000;
	rotationalDrag		= 0;

	// Advanced Steering
   steeringAutoReturn = true;
   steeringAutoReturnRate = 1;
   steeringAutoReturnMaxSpeed = 10;
   steeringUseStrafeSteering = true;
   steeringStrafeSteeringRate = 0.08;
	
	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = jeepSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = VehicleFoamDropletsEmitter;
	splashEmitter[1] = VehicleFoamEmitter;
	splashEmitter[2] = VehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
			
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;
	rideable = true;
		lookUpLimit = 0.50;
		lookDownLimit = 0.50;

	paintable = true;
   
   damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

   damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;


   numDmgEmitterAreas = 1;

  handsOnVehicle = 1;

   initialExplosionProjectile = BoltExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 4000;

   finalExplosionProjectile = BoltFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now


   minRunOverSpeed    = 2;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 5;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed
};
datablock WheeledVehicleData(SuperBoltVehicle : BoltVehicle)
{
   isCustom=1;
   type="Bolt SuperSport";
	uiName = "Bolt SuperSport";
	shapeFile = "./SuperBolt.dts";
	maxWheelSpeed=BoltVehicle.maxWheelSpeed+17;
        defaultTire	= SuperBoltTire;
        finalExplosionProjectile = SuperBoltFinalExplosionProjectile;
        engineTorque = BoltVehicle.engineTorque+750;
        engineBrake = BoltVehicle.engineBrake+500;   
        brakeTorque = BoltVehicle.brakeTorque+1200;
};
Garage_AddParts("add-ons/Vehicle_Bolt/Bolt.txt");

function BoltVehicle::onAdd(%this,%obj)
{
 Parent::onAdd(%this,%obj);
 %obj.hideNode(lhand);
 %obj.hideNode(rhand);
 %obj.hideNode(lhook);
 %obj.hideNode(rhook);
 %obj.schedule(0,garageDefault);
}
function SuperBoltVehicle::onAdd(%this,%obj)
{
   BoltVehicle::onAdd(%this,%obj);
}


package Vehicle_Bolt
{
	function serverCmdLight(%client)
	{	
		if(isObject(%client.player) && !isObject(%client.player.light))
		{
			%player = %client.Player;
			%coach = %player.getControlObject();

			if(isObject(%coach))
				if(%coach.getDatablock() == BoltVehicle.getID())
				{
					if(%coach.door == 1)
					{
						%coach.door = 0;
						%coach.playthread(0,open);
					}
					else
					{
						%coach.door = 1;
						%coach.playthread(0,close);
					}
					return;
				}
		}
		parent::serverCmdLight(%client);
	}
};
activatePackage(Vehicle_Bolt);

package Vehicle_SuperBolt
{
	function serverCmdLight(%client)
	{	
		if(isObject(%client.player) && !isObject(%client.player.light))
		{
			%player = %client.Player;
			%coach = %player.getControlObject();

			if(isObject(%coach))
				if(%coach.getDatablock() == SuperBoltVehicle.getID())
				{
					if(%coach.door == 1)
					{
						%coach.door = 0;
						%coach.playthread(0,open);
					}
					else
					{
						%coach.door = 1;
						%coach.playthread(0,close);
					}
					return;
				}
		}
		parent::serverCmdLight(%client);
	}
};
activatePackage(Vehicle_SuperBolt);