datablock WheeledVehicleTire(BoltTire)
{
   // Tires act as springs and generate lateral and longitudinal
   // forces to move the vehicle. These distortion/spring forces
   // are what convert wheel angular velocity into forces that
   // act on the rigid body.
   shapeFile = "./BoltWheel.dts";
	
	mass = 10;
    radius = 1.5;
    staticFriction = 1.65;
   kineticFriction = 5;
   restitution = 0.5;	

   // Spring that generates lateral tire forces
   lateralForce = 18000;
   lateralDamping = 4000;
   lateralRelaxation = 0.8;

   // Spring that generates longitudinal tire forces
   longitudinalForce = 14000;
   longitudinalDamping = 2000;
   longitudinalRelaxation = 0.8;
};

datablock WheeledVehicleTire(SuperBoltTire : BoltTire)
{
        shapeFile = "./SuperBoltWheel.dts";
};